unit ufrmMainNoFactory;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TfrmMainNoFactory = class(TForm)
    lstToys: TListBox;
    cmdSet1: TButton;
    cmdSet2: TButton;
    cmdSet3: TButton;
    cmdPlay: TButton;
    cmdTidy: TButton;
    cmdGive: TButton;
    rgrpToyTypes: TRadioGroup;
    cmdClose: TButton;
    procedure cmdSet1Click(Sender: TObject);
    procedure cmdSet2Click(Sender: TObject);
    procedure cmdSet3Click(Sender: TObject);
    procedure cmdPlayClick(Sender: TObject);
    procedure cmdTidyClick(Sender: TObject);
    procedure cmdGiveClick(Sender: TObject);
    procedure rgrpToyTypesClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure cmdCloseClick(Sender: TObject);
  private
    { Private declarations }
    FToyType: integer;

  public
    { Public declarations }
  end;

var
  frmMainNoFactory: TfrmMainNoFactory;

implementation

uses
  uToy
  , uBricks
  , uDolls
  ;

{$R *.DFM}

procedure TfrmMainNoFactory.cmdSet1Click(Sender: TObject);
var
  nItem: integer;
begin
  // Get set no. 1
  case rgrpToyTypes.ItemIndex of
    0:
    begin
      nItem := lstToys.Items.AddObject('', TBricks.Create);
      TBricks(lstToys.Items.Objects[nItem]).SetNo := 1;
    end;
    1:
    begin
      nItem := lstToys.Items.AddObject('', TDolls.Create);
      TDolls(lstToys.Items.Objects[nItem]).SetNo := 1;
    end;
    else Exit;
  end;
  lstToys.Items.Strings[nItem] := TToy(lstToys.Items.Objects[nItem]).Name;
end;

procedure TfrmMainNoFactory.cmdSet2Click(Sender: TObject);
var
  nItem: integer;
begin
  // Get set no. 2
  case rgrpToyTypes.ItemIndex of
    0:
    begin
      nItem := lstToys.Items.AddObject('', TBricks.Create);
      TBricks(lstToys.Items.Objects[nItem]).SetNo := 2;
    end;
    1:
    begin
      nItem := lstToys.Items.AddObject('', TDolls.Create);
      TDolls(lstToys.Items.Objects[nItem]).SetNo := 2;
    end;
    else Exit;
  end;
  lstToys.Items.Strings[nItem] := TToy(lstToys.Items.Objects[nItem]).Name;
end;

procedure TfrmMainNoFactory.cmdSet3Click(Sender: TObject);
var
  nItem: integer;
begin
  // Get set no. 3
  case rgrpToyTypes.ItemIndex of
    0:
    begin
      nItem := lstToys.Items.AddObject('', TBricks.Create);
      TBricks(lstToys.Items.Objects[nItem]).SetNo := 3;
    end;
    1:
    begin
      nItem := lstToys.Items.AddObject('', TDolls.Create);
      TDolls(lstToys.Items.Objects[nItem]).SetNo := 3;
    end;
    else Exit;
  end;
  lstToys.Items.Strings[nItem] := TToy(lstToys.Items.Objects[nItem]).Name;
end;

procedure TfrmMainNoFactory.cmdPlayClick(Sender: TObject);
begin
  // Play with the selected toy set
  if (lstToys.ItemIndex > -1) then
    TToy(lstToys.Items.Objects[lstToys.ItemIndex]).PlayWithMe;
end;

procedure TfrmMainNoFactory.cmdTidyClick(Sender: TObject);
begin
  // Tidy the selected toy set away
  if (lstToys.ItemIndex > -1) then
    TToy(lstToys.Items.Objects[lstToys.ItemIndex]).TidyMeAway;
end;

procedure TfrmMainNoFactory.cmdGiveClick(Sender: TObject);
begin
  // Give the selected toy set away to another child
  if (lstToys.ItemIndex > -1) then
  begin
    TToy(lstToys.Items.Objects[lstToys.ItemIndex]).Free;
    lstToys.Items.Delete(lstToys.ItemIndex);
  end;
end;

procedure TfrmMainNoFactory.rgrpToyTypesClick(Sender: TObject);
begin
  try
    if (lstToys.Items.Count > 0) then
    begin
      raise Exception.Create('You must give away all your toys before you can have one of a different type');
    end;
    FToyType := rgrpToyTypes.ItemIndex;
  except
    rgrpToyTypes.ItemIndex := FToyType;
    raise;
  end;
end;

procedure TfrmMainNoFactory.FormCreate(Sender: TObject);
begin
  FToyType := -1;
end;

procedure TfrmMainNoFactory.cmdCloseClick(Sender: TObject);
begin
  Self.Close;
end;

end.
